<script>
  import { scaleLinear } from "d3-scale";
  import {scaleOrdinal} from "d3-scale";
  import {scaleLog} from 'd3-scale';
  import {scaleSqrt} from 'd3-scale';
  import {schemeSet2}from 'd3-scale-chromatic';
  import {extent} from 'd3-array';
  import {axisLeft} from 'd3-axis';
  import{axisBottom} from 'd3-axis';
  import {select} from 'd3-selection';
  
    // Dimensions
    const [height, width] = [400, 600];
    const margin = { top: 50, right: 5, bottom: 55, left: 50 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;
    export let data;
    const classcolour = extent(data, (d) => d.continent);
    const scaleValues_x=scaleLog()
    .domain([300,100000])
    .range([0,innerWidth]);
    const scaleValues_y=scaleLinear()
    .domain([0,90])
    .range([innerHeight,0]);
    const ordinal=scaleOrdinal()
    .range(schemeSet2)
    .domain(classcolour);
    const radius=scaleSqrt()
    .domain([0,5e8])
    .range([5,10]);
    const ticks=[400,4000,40000];
  
   function my_yaxis(element){
     let yaxis=axisLeft(scaleValues_y);
     select(element).call(yaxis);
   }
  
   function my_xaxis(element){
    let xaxis=axisBottom(scaleValues_x)
      .tickValues(ticks);
      select(element).call(xaxis);
   }
  
  
  </script>
  
  <svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
    <text  x=0 y=0 transform=" translate(20,250) rotate(270)" fill="currentColor" style="font-size:1em;">Life Expectancy </text>
    <g transform="translate({margin.left}, {margin.top})">
        {#each data as value}
        {#if value.income !== null && value.life_exp !== null && value.population !== null}
        <circle r={radius(+value.population)}  cy={scaleValues_y(+value.life_exp)} cx={scaleValues_x(+value.income)} style="fill: {ordinal(value.continent)};"/>
        {/if}
        {/each}
        <text  x={innerWidth/2-margin.left} y={height-1.5*margin.top} fill="currentColor" style="font-size:1em;">GDP per Capita </text>
        <text x={innerWidth/2-2.5*margin.left}  y=0 style="font-size:2em;"> Gapminder Scatterplot </text>
        <text x={innerWidth-50}, y={innerHeight-10} style="font-size:1.5em; opacity: 0.5;">1800</text>
        {#each ticks as tick}
        <text  x={scaleValues_x(+tick)-10}  y={height-1.8*margin.top} fill="currentColor" style="font-size:0.65em;">${tick} </text>
        {/each}
    </g>
    <g transform="translate({margin.left},{margin.top})" use:my_yaxis>
    </g>
    <g transform="translate({margin.left},{innerHeight+margin.top})" use:my_xaxis>
    </g>
  
  </svg>
  